# -*- coding: utf-8 -*-
"""
Global configuration file for TG2-specific settings in luci.

This file complements development/deployment.ini.

Please note that **all the argument values are strings**. If you want to
convert them into boolean, for example, you should use the
:func:`paste.deploy.converters.asbool` function, as in::
    
    from paste.deploy.converters import asbool
    setting = asbool(global_conf.get('the_setting'))
 
"""

from tg.configuration import AppConfig

import luci
from luci import model
from luci.lib import app_globals, helpers

base_config = AppConfig()
base_config.renderers = []

base_config.package = luci

#Set the default renderer
base_config.default_renderer = 'genshi'
base_config.renderers.append('genshi')

#Configure the base SQLALchemy Setup
base_config.use_sqlalchemy = True
base_config.model = luci.model
base_config.DBSession = luci.model.DBSession
