function add_fenceinst(parent_id, fence_type, fence_device) {
    var form_jelem = $(document.getElementById(parent_id));
    if (!form_jelem) {
        return;
    }
    var num_inst = 1;
    if (!fence_type) {
        return;
    }
    var inst_form_jelem = $(document.getElementById(fence_type + '_instance')).clone();
    if (!inst_form_jelem) {
        return;
    }

    var fenceinst_id = parent_id;
    $(inst_form_jelem).attr('id', fenceinst_id);
    $(inst_form_jelem).attr('class', 'fenceinst');

    var parent_dev = $('input[name="parent_fencedev"]', inst_form_jelem);
    $(parent_dev).val(fence_device);

    $('input[name="remove_fence"]', inst_form_jelem).remove();
    $(form_jelem).replaceWith($(inst_form_jelem));
}

function swap_fence_form(fence_form_id, flevel) {
    var container_id = 'fence_list_level' + flevel;
    var form_jelem = $(document.getElementById(fence_form_id)).clone();
    var cont_jelem = $(document.getElementById(container_id));
    var num_fdev = $(document.getElementById('num_fences_level_' + flevel));
    $(num_fdev).val(Number($(num_fdev).val()) + 1);
    var fencedev_id;
    var containing_div = $('<div class="fencedev"></div>');

    if (!form_jelem || !cont_jelem) {
        return;
    }

    fencedev_id = 'fence_' + flevel + '_' + $(num_fdev).val();
    $(containing_div).attr('id', fencedev_id);

    $(form_jelem).removeAttr('id');

    var input_elems = $(':input', form_jelem);
    var sharable = $('input[name="sharable"]', form_jelem).val();
    var existing = $('input[name="existing_device"]', form_jelem).val();

    if (existing) {
        $(input_elems).attr('disabled', 'disabled');
    }

    $(form_jelem).appendTo($(containing_div));
    $('<div class="fence_instances"/>').appendTo($(containing_div));
    $(containing_div).appendTo($(cont_jelem));
    if (sharable) {
        
        add_fenceinst(fencedev_id);
        $(containing_div).append('<input type="button" onclick="' + 'add_fenceinst(\''  + fencedev_id + '\')" value="Add instance">');
    }
    $(containing_div).append('<input type="button" onclick="' + '$(\'#' + fencedev_id + '\').remove()' + '" value="Remove this fence device">');
}

function gen_fence_xml(form) {
    var fence_div_jelem = [ '#primary_fence_dev', '#secondary_fence_dev' ];
    var fence_xml_field = [ form.level1_xml, form.level2_xml ];

    for (var i = 0 ; i < fence_div_jelem.length ; i++) {
        var level_xml_str = "";
        var device_jelem = $(fence_div_jelem[i]).find('.fencedev');

        /* Iterate over each device in each level */
        for (var fd = 0 ; fd < $(device_jelem).length ; fd++) {
            var cur_fd = $(device_jelem).eq(fd);
            var device_form = $(cur_fd).find('.fencedevform');
            var cur_fence_id = $(cur_fd).attr('id');
            var fence_dev_input = $(':input', device_form);
            var cur_xml_str = '<form id="' + cur_fence_id + '">';
            $(fence_dev_input).each(function(idx) {
                cur_xml_str += input_to_xml(this);
            });
            cur_xml_str += '</form>'
            level_xml_str += cur_xml_str;

            /* Iterate over each instance of the current device */
            var inst_jelem = $(cur_fd).find('.fenceinst');
            for (var fi = 0 ; fi < $(inst_jelem).length ; fi++) {
                var cur_fi = $(inst_jelem).eq(fi);
                var cur_fi_id = $(cur_fi).attr('id');
                var fence_inst_input = $(':input', cur_fi)
                var inst_xml_str = '<form id="' + cur_fi_id + '">';
                $(fence_inst_input).each(function(idx) {
                    inst_xml_str += input_to_xml(this);
                });
                inst_xml_str += '</form>'
                level_xml_str += inst_xml_str;
            }
        }

        fence_xml_field[i].value = '<formlist>' + level_xml_str + '</formlist>';
    }
    form.submit();
}
